const state = {
    date: {
        default: null,
        value: this.default
    },
    loadingDate: {
        default: false,
        value: true
    }
}

const getters = {
    /**
     * 
     * @param {*} state 
     */
    date(state) {
        return state.date.value
    },
    /**
     * 
     * @param {*} state 
     */
    loadingDate(state) {
        return state.loadingDate.value
    }
}

const mutations = {
    /**
     * 
     * @param {*} state 
     * @param {*} payload 
     */
    setDate(state, payload) {
        state.date.value = payload
    },
    /**
     * 
     * @param {*} state 
     * @param {*} payload 
     */
    setLoadingDate(state, payload) {
        state.loadingDate.value = !!payload
    }
}

const actions = {
    /**
     * 
     * @param {*} param0 
     * @param {*} payload 
     */
    initDate({ commit }, payload) {
        commit('setDate', payload)
        commit('setLoadingDate', false)
    }
}

export default {
    state,
    getters,
    mutations,
    actions
}