const state = {
    journals: {
        default: [],
        values: []
    },
    loadingJournals: {
        default: false,
        value: true
    },
    selectedJournal: {
        default: null,
        value: null
    }
}

const getters = {
    /**
     * 
     * @param {*} state 
     */
    journals(state) {
        return state.journals.values
    },
    /**
     * 
     * @param {*} state 
     */
    selectedJournal(state) {
        return state.selectedJournal.value
    },
    /**
     * 
     * @param {*} state 
     * @param {*} payload 
     */
    setLoadingJournals(state, payload) {
        return state.loadingJournals.value
    }
}

const mutations = {
    /**
     * 
     * @param {*} state 
     * @param {*} payload 
     */
    setJournals(state, payload) {
        state.journals.values = [...payload]
    },
    /**
     * 
     * @param {*} state 
     * @param {*} payload 
     */
    autoSelectJournal(state) {
        state.selectedJournal.value = state.journals.values.find(item => item.type === 'cash')
    },
    /**
     * 
     * @param {*} state 
     * @param {*} payload 
     */
    setSelectedJournal(state, payload) {
        state.selectedJournal.value = payload
    },
    /**
     * 
     * @param {*} state 
     * @param {*} payload 
     */
    setLoadingJournals(state, payload) {
        state.loadingJournals.value = !!payload
    }
}

const actions = {
    /**
     * 
     * @param {*} param0 
     * @param {*} payload 
     */
    initJournals({ commit }, payload) {
        commit('setJournals', payload)
        commit('autoSelectJournal')
        commit('setLoadingJournals', false)
    },
    /**
     * 
     * @param {*} param0 
     * @param {*} payload 
     */
    selectJournal({ commit }, payload) {
        commit('setSelectedJournal', payload)
    }
}

export default {
    state,
    getters,
    mutations,
    actions
}