const state = {
    user: {
        default: null,
        value: null
    },
    loadingUser: {
        default: false,
        value: true
    }
}

const getters = {
    /**
     * 
     * @param {*} state 
     */
    user(state) {
        return state.user.value
    },
    /**
     * 
     * @param {*} state 
     */
    loadingUser(state) {
        return state.loadingUser.value
    }
}

const mutations = {
    /**
     * 
     * @param {*} state 
     * @param {*} payload 
     */
    setUser(state, payload) {
        state.user.value = payload
    },
    /**
     * 
     * @param {*} state 
     * @param {*} payload 
     */
    setLoadingUser(state, payload) {
        state.loadingUser.value = !!payload
    }
}

const actions = {
    /**
     * 
     * @param {*} param0 
     * @param {*} payload 
     */
    initUser({ commit }, payload) {
        commit('setUser', payload)
        commit('setLoadingUser', false)
    }
}

export default {
    state,
    getters,
    mutations,
    actions
}